Index: gtags-cscope/edit.c
===================================================================
RCS file: /sources/global/global/gtags-cscope/edit.c,v
retrieving revision 1.10
diff -c -r1.10 edit.c
*** gtags-cscope/edit.c	8 Sep 2015 03:22:52 -0000	1.10
--- gtags-cscope/edit.c	4 May 2024 18:43:05 -0000
***************
*** 1,7 ****
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation 
   All rights reserved.
!  
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
--- 1,7 ----
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation
   All rights reserved.
! 
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
***************
*** 14,20 ****
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission. 
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
--- 14,20 ----
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission.
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
***************
*** 27,33 ****
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE. 
   =========================================================================*/
  
  /*
--- 27,33 ----
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE.
   =========================================================================*/
  
  /*
***************
*** 59,65 ****
  	}
  	/* get the selected line */
  	seekline(i + topline);
! 	
  	/* get the file name and line number */
  	if (fscanf(refsfound, "%" PATHLEN_STR "s%*s%" NUMLEN_STR "s", file, linenum) == 2) {
  		edit(decode_path(file), linenum);	/* edit it */
--- 59,65 ----
  	}
  	/* get the selected line */
  	seekline(i + topline);
! 
  	/* get the file name and line number */
  	if (fscanf(refsfound, "%" PATHLEN_STR "s%*s%" NUMLEN_STR "s", file, linenum) == 2) {
  		edit(decode_path(file), linenum);	/* edit it */
***************
*** 82,88 ****
  	}
  	/* get the first line */
  	seekline(1);
! 	
  	/* get each file name and line number */
  	while (fscanf(refsfound, "%" PATHLEN_STR "s%*s%" NUMLEN_STR "s%*[^\n]", file, linenum) == 2) {
  		edit(decode_path(file), linenum);	/* edit it */
--- 82,88 ----
  	}
  	/* get the first line */
  	seekline(1);
! 
  	/* get each file name and line number */
  	while (fscanf(refsfound, "%" PATHLEN_STR "s%*s%" NUMLEN_STR "s%*[^\n]", file, linenum) == 2) {
  		edit(decode_path(file), linenum);	/* edit it */
***************
*** 95,101 ****
  	}
  	seekline(topline);
  }
! 	
  /** call the editor */
  
  void
--- 95,101 ----
  	}
  	seekline(topline);
  }
! 
  /** call the editor */
  
  void
***************
*** 111,126 ****
  	(void) snprintf(plusnum, sizeof(plusnum), lineflag, linenum);
  	/* if this is the more or page commands */
  	if (strcmp(s = mybasename(editor), "more") == 0 || strcmp(s, "page") == 0) {
! 		
  		/* get it to pause after displaying a file smaller than the screen
  		   length */
! 		(void) execute(editor, editor, plusnum, file, NULL_DEVICE, NULL);
! 	}
! 	else if (lineflagafterfile) {
! 		(void) execute(editor, editor, file, plusnum, NULL);
! 	}
! 	else {
! 		(void) execute(editor, editor, plusnum, file, NULL);
  	}
  	clear();	/* redisplay screen */
  }
--- 111,133 ----
  	(void) snprintf(plusnum, sizeof(plusnum), lineflag, linenum);
  	/* if this is the more or page commands */
  	if (strcmp(s = mybasename(editor), "more") == 0 || strcmp(s, "page") == 0) {
! 
  		/* get it to pause after displaying a file smaller than the screen
  		   length */
!             if (editor_options)
! 		(void) execute(editor, editor_options, plusnum, file, NULL_DEVICE, NULL);
!             else
! 		(void) execute(editor, NULL, plusnum, file, NULL_DEVICE, NULL);
! 	} else if (lineflagafterfile) {
!             if (editor_options)
! 		(void) execute(editor, editor_options, file, plusnum, NULL);
!             else
! 		(void) execute(editor, NULL, file, plusnum, NULL);
! 	} else {
!             if (editor_options)
! 		(void) execute(editor, editor_options, plusnum, file, NULL);
!             else
! 		(void) execute(editor, NULL, plusnum, file, NULL);
  	}
  	clear();	/* redisplay screen */
  }
***************
*** 131,137 ****
  filepath(char *file)
  {
  	static	char	path[PATHLEN + 1];
! 	
  	if (prependpath != NULL && *file != '/') {
  		(void) snprintf(path, sizeof(path), "%s/%s", prependpath, file);
  		file = path;
--- 138,144 ----
  filepath(char *file)
  {
  	static	char	path[PATHLEN + 1];
! 
  	if (prependpath != NULL && *file != '/') {
  		(void) snprintf(path, sizeof(path), "%s/%s", prependpath, file);
  		file = path;
Index: gtags-cscope/exec.c
===================================================================
RCS file: /sources/global/global/gtags-cscope/exec.c,v
retrieving revision 1.6
diff -c -r1.6 exec.c
*** gtags-cscope/exec.c	8 Sep 2015 03:22:52 -0000	1.6
--- gtags-cscope/exec.c	4 May 2024 18:43:05 -0000
***************
*** 1,7 ****
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation 
   All rights reserved.
!  
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
--- 1,7 ----
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation
   All rights reserved.
! 
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
***************
*** 14,20 ****
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission. 
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
--- 14,20 ----
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission.
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
***************
*** 27,33 ****
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE. 
   =========================================================================*/
  
  /*
--- 27,33 ----
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE.
   =========================================================================*/
  
  /*
***************
*** 72,91 ****
  
  /*VARARGS1*/
  int
! execute(char *a, ...)	/* note: "exec" is already defined on u370 */
  {
  	va_list	ap;
  	int	exitcode = -1;	/* initialize, to avoid warning */
  	char	*argv[BUFSIZ];
! 	pid_t	p;
  
  	/* fork and exec the program or shell script */
  	endwin();	/* restore the terminal modes */
  	mousecleanup();
  	fflush(stdout);
! 	va_start(ap, a);
! 	for (p = 0; (argv[p] = va_arg(ap, char *)) != 0; p++)
! 		;
  #if !HAVE_FORK
  	/* HBB 20010313: in MSDOG, everything is completely different.
  	 * No fork()/exec()/wait(), but rather a single libc call: */
--- 72,99 ----
  
  /*VARARGS1*/
  int
! execute(char *a, char **opts, ...)	/* note: "exec" is already defined on u370 */
  {
  	va_list	ap;
  	int	exitcode = -1;	/* initialize, to avoid warning */
  	char	*argv[BUFSIZ];
! 	pid_t	p = 0;
  
  	/* fork and exec the program or shell script */
  	endwin();	/* restore the terminal modes */
  	mousecleanup();
  	fflush(stdout);
! 	va_start(ap, opts);
!         argv[0] = a; p++; /* the first argument should be the executable's name */
! 
!         if (opts) {
!             for (int i = 0; opts[i] != 0; i++) {
!                 argv[p] = opts[i]; p++;
!             }
!         }
! 
! 	for (; (argv[p] = va_arg(ap, char *)) != 0; p++)
!             ;
  #if !HAVE_FORK
  	/* HBB 20010313: in MSDOG, everything is completely different.
  	 * No fork()/exec()/wait(), but rather a single libc call: */
***************
*** 98,107 ****
  		exitcode = join(p);	/* parent */
  	}
  #endif /* MSDOS */
! 	
  	/* the menu and scrollbar may be changed by the command executed */
  #if UNIXPC || !TERMINFO
! # ifndef __DJGPP__ /* leave CRLF handling as is */      
  	nonl();
  # endif
  	raw();	/* endwin() turns off cbreak mode so restore it */
--- 106,115 ----
  		exitcode = join(p);	/* parent */
  	}
  #endif /* MSDOS */
! 
  	/* the menu and scrollbar may be changed by the command executed */
  #if UNIXPC || !TERMINFO
! # ifndef __DJGPP__ /* leave CRLF handling as is */
  	nonl();
  # endif
  	raw();	/* endwin() turns off cbreak mode so restore it */
***************
*** 122,128 ****
  myexecvp(char *a, char **args)
  {
      char    msg[MSGLEN + 1];
! 	
      /* modify argv[0] to reference the last component of its path name */
      args[0] = mybasename(args[0]);
  
--- 130,136 ----
  myexecvp(char *a, char **args)
  {
      char    msg[MSGLEN + 1];
! 
      /* modify argv[0] to reference the last component of its path name */
      args[0] = mybasename(args[0]);
  
***************
*** 144,157 ****
  	pid_t	p;		/* process number */
  
  	p = fork();
! 	
  	/* the parent ignores the interrupt, quit, and hangup signals */
  	if (p > 0) {
  		oldsigquit = signal(SIGQUIT, SIG_IGN);
  		oldsighup = signal(SIGHUP, SIG_IGN);
! #ifdef SIGTSTP		
  		oldsigtstp = signal(SIGTSTP, SIG_DFL);
! #endif		
  	}
  	/* so they can be used to stop the child */
  	else if (p == 0) {
--- 152,165 ----
  	pid_t	p;		/* process number */
  
  	p = fork();
! 
  	/* the parent ignores the interrupt, quit, and hangup signals */
  	if (p > 0) {
  		oldsigquit = signal(SIGQUIT, SIG_IGN);
  		oldsighup = signal(SIGHUP, SIG_IGN);
! #ifdef SIGTSTP
  		oldsigtstp = signal(SIGTSTP, SIG_DFL);
! #endif
  	}
  	/* so they can be used to stop the child */
  	else if (p == 0) {
***************
*** 160,166 ****
  		signal(SIGHUP, SIG_DFL);
  #ifdef SIGTSTP
  		signal(SIGTSTP, SIG_DFL);
! #endif			
  	}
  	/* check for fork failure */
  	if (p == -1) {
--- 168,174 ----
  		signal(SIGHUP, SIG_DFL);
  #ifdef SIGTSTP
  		signal(SIGTSTP, SIG_DFL);
! #endif
  	}
  	/* check for fork failure */
  	if (p == -1) {
***************
*** 172,180 ****
  /** join is the compliment of fork */
  
  static int
! join(pid_t p) 
  {
! 	int	status;  
  	pid_t	w;
  
  	/* wait for the correct child to exit */
--- 180,188 ----
  /** join is the compliment of fork */
  
  static int
! join(pid_t p)
  {
! 	int	status;
  	pid_t	w;
  
  	/* wait for the correct child to exit */
***************
*** 187,193 ****
  	signal(SIGHUP, oldsighup);
  #ifdef SIGTSTP
  	signal(SIGTSTP, oldsigtstp);
! #endif	
  
  	/* return the child's exit code */
  	return(status >> 8);
--- 195,201 ----
  	signal(SIGHUP, oldsighup);
  #ifdef SIGTSTP
  	signal(SIGTSTP, oldsigtstp);
! #endif
  
  	/* return the child's exit code */
  	return(status >> 8);
Index: gtags-cscope/global-cscope.h
===================================================================
RCS file: /sources/global/global/gtags-cscope/global-cscope.h,v
retrieving revision 1.9
diff -c -r1.9 global-cscope.h
*** gtags-cscope/global-cscope.h	15 May 2019 18:36:51 -0000	1.9
--- gtags-cscope/global-cscope.h	4 May 2024 18:43:05 -0000
***************
*** 1,7 ****
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation 
   All rights reserved.
!  
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
--- 1,7 ----
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation
   All rights reserved.
! 
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
***************
*** 14,20 ****
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission. 
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
--- 14,20 ----
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission.
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
***************
*** 27,33 ****
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE. 
   =========================================================================*/
  
  /* $Id: global-cscope.h,v 1.9 2019/05/15 18:36:51 h-iwamoto Exp $ */
--- 27,33 ----
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE.
   =========================================================================*/
  
  /* $Id: global-cscope.h,v 1.9 2019/05/15 18:36:51 h-iwamoto Exp $ */
***************
*** 72,78 ****
  # ifndef HAVE_MEMSET
  #  ifndef HAVE_MEMORY_H
  char	*memset();
! #  else 
  #   include <memory.h>	/* memset */
  #  endif /*V9*/
  # endif /* HAVE_MEMSET */
--- 72,78 ----
  # ifndef HAVE_MEMSET
  #  ifndef HAVE_MEMORY_H
  char	*memset();
! #  else
  #   include <memory.h>	/* memset */
  #  endif /*V9*/
  # endif /* HAVE_MEMSET */
***************
*** 98,106 ****
  #if BSD
  # undef	tolower		/* BSD toupper and tolower don't test the character */
  # undef	toupper
! # define	tolower(c)	(isupper(c) ? (c) - 'A' + 'a' : (c))	
  # define	toupper(c)	(islower(c) ? (c) - 'a' + 'A' : (c))
! # if !sun 
  #  if !__FreeBSD__
  /* in traditional BSD, *printf() doesn't return the number of bytes
   * written */
--- 98,106 ----
  #if BSD
  # undef	tolower		/* BSD toupper and tolower don't test the character */
  # undef	toupper
! # define	tolower(c)	(isupper(c) ? (c) - 'A' + 'a' : (c))
  # define	toupper(c)	(islower(c) ? (c) - 'a' + 'A' : (c))
! # if !sun
  #  if !__FreeBSD__
  /* in traditional BSD, *printf() doesn't return the number of bytes
   * written */
***************
*** 115,121 ****
  /* #define SHORT_NAMES_ONLY */
  
  /* Just in case autoconf didn't correctly flag HAVE_FIXKEYPAD */
! #ifndef HAVE_FIXKEYPAD 
  # if SVR2 && !BSD && !V9 && !u3b2 && !sun
  #  define HAVE_FIXKEYPAD
  # endif
--- 115,121 ----
  /* #define SHORT_NAMES_ONLY */
  
  /* Just in case autoconf didn't correctly flag HAVE_FIXKEYPAD */
! #ifndef HAVE_FIXKEYPAD
  # if SVR2 && !BSD && !V9 && !u3b2 && !sun
  #  define HAVE_FIXKEYPAD
  # endif
***************
*** 143,149 ****
  # else
  #  define O_BINARY 0x00
  # endif
! #endif 
  
  #undef SETMODE
  #if O_BINARY || O_TEXT
--- 143,149 ----
  # else
  #  define O_BINARY 0x00
  # endif
! #endif
  
  #undef SETMODE
  #if O_BINARY || O_TEXT
***************
*** 151,157 ****
   * to actually do something */
  # ifdef HAVE_SETMODE
  #  define SETMODE(fildes, mode) setmode(fildes,mode)
! # else 
  #  ifdef HAVE__SETMODE
  #   define SETMODE(fildes, mode) _setmode(fildes,mode)
  #  endif
--- 151,157 ----
   * to actually do something */
  # ifdef HAVE_SETMODE
  #  define SETMODE(fildes, mode) setmode(fildes,mode)
! # else
  #  ifdef HAVE__SETMODE
  #   define SETMODE(fildes, mode) _setmode(fildes,mode)
  #  endif
***************
*** 163,169 ****
  #ifdef R_OK
  # define	READ	R_OK
  #else
! # define	READ	4	
  #endif
  #ifdef W_OK
  # define	WRITE	W_OK
--- 163,169 ----
  #ifdef R_OK
  # define	READ	R_OK
  #else
! # define	READ	4
  #endif
  #ifdef W_OK
  # define	WRITE	W_OK
***************
*** 216,222 ****
  };
  
  /* main.c global data */
! extern	char	*editor, *home, *shell, *lineflag;	/**< environment variables */
  extern	char	*global_command;			/**< "global" by default */
  extern	char	*gtags_command;				/**< "gtags" by default */
  extern	char	*home;		/**< Home directory */
--- 216,224 ----
  };
  
  /* main.c global data */
! extern	char	*editor, *home, *shell, *lineflag; /**< environment variables */
! extern	char	**editor_options; /** The editor options if any */
! extern  int     options_number;
  extern	char	*global_command;			/**< "global" by default */
  extern	char	*gtags_command;				/**< "gtags" by default */
  extern	char	*home;		/**< Home directory */
***************
*** 274,280 ****
  extern	BOOL	unixpcmouse;		/**< UNIX PC mouse interface */
  #endif
  
! /* cscope functions called from more than one function or between files */ 
  
  char	*filepath(char *file);
  char	*findcalledby(char *pattern);
--- 276,282 ----
  extern	BOOL	unixpcmouse;		/**< UNIX PC mouse interface */
  #endif
  
! /* cscope functions called from more than one function or between files */
  
  char	*filepath(char *file);
  char	*findcalledby(char *pattern);
***************
*** 358,363 ****
  int	egrep(char *file, FILE *output, char *format);
  int	mygetline(char p[], char s[], unsigned size, int firstchar, BOOL iscaseless);
  int	mygetch(void);
! int	execute(char *a, ...);
  
  #endif /* CSCOPE_GLOBAL_H */
--- 360,365 ----
  int	egrep(char *file, FILE *output, char *format);
  int	mygetline(char p[], char s[], unsigned size, int firstchar, BOOL iscaseless);
  int	mygetch(void);
! int	execute(char *a, char **opts, ...);
  
  #endif /* CSCOPE_GLOBAL_H */
Index: gtags-cscope/gtags-cscope.c
===================================================================
RCS file: /sources/global/global/gtags-cscope/gtags-cscope.c,v
retrieving revision 1.34
diff -c -r1.34 gtags-cscope.c
*** gtags-cscope/gtags-cscope.c	12 Jan 2018 00:18:02 -0000	1.34
--- gtags-cscope/gtags-cscope.c	4 May 2024 18:43:05 -0000
***************
*** 1,7 ****
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation 
   All rights reserved.
!  
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
--- 1,7 ----
  /*===========================================================================
!  Copyright (c) 1998-2000, The Santa Cruz Operation
   All rights reserved.
! 
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
  
***************
*** 14,20 ****
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission. 
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
--- 14,20 ----
  
   *Neither name of The Santa Cruz Operation nor the names of its contributors
   may be used to endorse or promote products derived from this software
!  without specific prior written permission.
  
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
   IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
***************
*** 27,33 ****
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE. 
   =========================================================================*/
  
  
--- 27,33 ----
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
!  DAMAGE.
   =========================================================================*/
  
  
***************
*** 42,47 ****
--- 42,48 ----
  #include "strbuf.h"
  #include "build.h"
  #include "version-cscope.h"	/* FILEVERSION and FIXVERSION */
+ #include "alloc.h"
  
  /* for libutil */
  #include "env.h"
***************
*** 88,93 ****
--- 89,96 ----
  #define TMPDIR	"/tmp"
  
  char	*editor, *shell, *lineflag;	/**< environment variables */
+ char    **editor_options = 0;              /** Editor flags if any **/
+ int     options_number = 0;              /** the number of options allocated **/
  char	*global_command;	/**< "global" by default */
  char	*gtags_command;		/**< "gtags" by default */
  char	*home;			/**< Home directory */
***************
*** 110,116 ****
  char	temp1[PATHLEN + 1];	/**< temporary file name */
  char	temp2[PATHLEN + 1];	/**< temporary file name */
  char	tempdirpv[PATHLEN + 1];	/**< private temp directory */
! char	tempstring[TEMPSTRING_LEN + 1]; /**< use this as a buffer, instead of yytext, 
  				 * which had better be left alone */
  char	*tmpdir;		/**< temporary directory */
  
--- 113,119 ----
  char	temp1[PATHLEN + 1];	/**< temporary file name */
  char	temp2[PATHLEN + 1];	/**< temporary file name */
  char	tempdirpv[PATHLEN + 1];	/**< private temp directory */
! char	tempstring[TEMPSTRING_LEN + 1]; /**< use this as a buffer, instead of yytext,
  				 * which had better be left alone */
  char	*tmpdir;		/**< temporary directory */
  
***************
*** 122,133 ****
  static	void	usage(void);
  int	qflag;
  
  #ifdef HAVE_FIXKEYPAD
  void	fixkeypad();
  #endif
- 
  #if defined(KEY_RESIZE) && defined(SIGWINCH)
! void 
  sigwinch_handler(int sig, siginfo_t *info, void *unused)
  {
      (void) sig;
--- 125,138 ----
  static	void	usage(void);
  int	qflag;
  
+ static void get_editor_options(void);
+ static void options_string_to_vector(char * options);
+ 
  #ifdef HAVE_FIXKEYPAD
  void	fixkeypad();
  #endif
  #if defined(KEY_RESIZE) && defined(SIGWINCH)
! void
  sigwinch_handler(int sig, siginfo_t *info, void *unused)
  {
      (void) sig;
***************
*** 149,155 ****
  #if defined(KEY_RESIZE) && defined(SIGWINCH)
      struct sigaction winch_action;
  #endif
! 	
      /* save the command name for messages */
      argv0 = argv[0];
  
--- 154,160 ----
  #if defined(KEY_RESIZE) && defined(SIGWINCH)
      struct sigaction winch_action;
  #endif
! 
      /* save the command name for messages */
      argv0 = argv[0];
  
***************
*** 173,179 ****
  	}
  
  	for (s = argv[0] + 1; *s != '\0'; s++) {
! 			
  	    /* look for an input field number */
  	    if (isdigit((unsigned char) *s)) {
  		field = *s - '0';
--- 178,184 ----
  	}
  
  	for (s = argv[0] + 1; *s != '\0'; s++) {
! 
  	    /* look for an input field number */
  	    if (isdigit((unsigned char) *s)) {
  		field = *s - '0';
***************
*** 261,267 ****
  		    s = *++argv;
  		}
  		if (*s == '\0') {
! 		    fprintf(stderr, "%s: -%c option: missing or empty value\n", 
  			    argv0, c);
  		    goto usage;
  		}
--- 266,272 ----
  		    s = *++argv;
  		}
  		if (*s == '\0') {
! 		    fprintf(stderr, "%s: -%c option: missing or empty value\n",
  			    argv0, c);
  		    goto usage;
  		}
***************
*** 281,287 ****
  		case 'p':	/* file path components to display */
  		    if (*s < '0' || *s > '9' ) {
  			fprintf(stderr, "\
! %s: -p option: missing or invalid numeric value\n", 
  				argv0);
  			goto usage;
  		    }
--- 286,292 ----
  		case 'p':	/* file path components to display */
  		    if (*s < '0' || *s > '9' ) {
  			fprintf(stderr, "\
! %s: -p option: missing or invalid numeric value\n",
  				argv0);
  			goto usage;
  		    }
***************
*** 297,303 ****
  		}
  		goto nextarg;
  	    default:
! 		fprintf(stderr, "%s: unknown option: -%c\n", argv0, 
  			*s);
  	    usage:
  		usage();
--- 302,308 ----
  		}
  		goto nextarg;
  	    default:
! 		fprintf(stderr, "%s: unknown option: -%c\n", argv0,
  			*s);
  	    usage:
  		usage();
***************
*** 305,311 ****
  		myexit(1);
  	    } /* switch(option letter) */
  	} /* for(option) */
!     nextarg:	
  	;
      } /* while(argv) */
  
--- 310,316 ----
  		myexit(1);
  	    } /* switch(option letter) */
  	} /* for(option) */
!     nextarg:
  	;
      } /* while(argv) */
  
***************
*** 314,319 ****
--- 319,325 ----
      editor = mygetenv("EDITOR", EDITOR);
      editor = mygetenv("VIEWER", editor); /* use viewer if set */
      editor = mygetenv("CSCOPE_EDITOR", editor);	/* has last word */
+     get_editor_options(); /* Remove options from editor if any */
      home = mygetenv("HOME", HOME);
      global_command = mygetenv("GTAGSGLOBAL", "global");
      gtags_command = mygetenv("GTAGSGTAGS", "gtags");
***************
*** 332,338 ****
      /* make sure that tmpdir exists */
      if (lstat (tmpdir, &stat_buf)) {
  	fprintf (stderr, "\
! cscope: Temporary directory %s does not exist or cannot be accessed\n", 
  		 tmpdir);
  	fprintf (stderr, "\
  cscope: Please create the directory or set the environment variable\n\
--- 338,344 ----
      /* make sure that tmpdir exists */
      if (lstat (tmpdir, &stat_buf)) {
  	fprintf (stderr, "\
! cscope: Temporary directory %s does not exist or cannot be accessed\n",
  		 tmpdir);
  	fprintf (stderr, "\
  cscope: Please create the directory or set the environment variable\n\
***************
*** 413,419 ****
  	strbuf_close(sb);
      } else {
  	if (linemode == NO || verbosemode == YES)    /* display if verbose as well */
! 	    postmsg("Building cross-reference...");                 
  	rebuild();
  	if (linemode == NO )
              clearmsg(); /* clear any build progress message */
--- 419,425 ----
  	strbuf_close(sb);
      } else {
  	if (linemode == NO || verbosemode == YES)    /* display if verbose as well */
! 	    postmsg("Building cross-reference...");
  	rebuild();
  	if (linemode == NO )
              clearmsg(); /* clear any build progress message */
***************
*** 424,430 ****
  
      /* opendatabase(); */
  
!     /* if using the line oriented user interface so cscope can be a 
         subprocess to emacs or samuel */
      if (linemode == YES) {
  	if (*Pattern != '\0') {		/* do any optional search */
--- 430,436 ----
  
      /* opendatabase(); */
  
!     /* if using the line oriented user interface so cscope can be a
         subprocess to emacs or samuel */
      if (linemode == YES) {
  	if (*Pattern != '\0') {		/* do any optional search */
***************
*** 441,450 ****
  	}
  	if (onesearch == YES)
  	    myexit(0);
! 		
  	for (;;) {
  	    char buf[PATLEN + 2];
! 			
  	    printf(">> ");
  	    fflush(stdout);
  	    if (fgets(buf, sizeof(buf), stdin) == NULL) {
--- 447,456 ----
  	}
  	if (onesearch == YES)
  	    myexit(0);
! 
  	for (;;) {
  	    char buf[PATLEN + 2];
! 
  	    printf(">> ");
  	    fflush(stdout);
  	    if (fgets(buf, sizeof(buf), stdin) == NULL) {
***************
*** 624,630 ****
  	 * about that, but DOS absolutely needs it */
  	if (refsfound != NULL)
  		fclose(refsfound);
! 	
  	/* remove any temporary files */
  	if (temp1[0] != '\0') {
  		unlink(temp1);
--- 630,636 ----
  	 * about that, but DOS absolutely needs it */
  	if (refsfound != NULL)
  		fclose(refsfound);
! 
  	/* remove any temporary files */
  	if (temp1[0] != '\0') {
  		unlink(temp1);
***************
*** 644,646 ****
--- 650,722 ----
  	/* HBB 20000421: be nice: free allocated data */
  	exit(sig);
  }
+ 
+ /* Modifies editor and editor_flags when $EDITOR has options
+    (whitespace separated elements), if there are no options it will not modify
+    any variable and editor_options will be null */
+ static void
+ get_editor_options(void)
+ {
+     int count = 0;
+     char *opts = editor, *_editor;
+ 
+     /* Now opts will point to where the args/opts begin */
+     for (int i = 0; *opts != '\0'; opts++, i++)
+         if (*opts == ' ') { count = i; break; }
+ 
+     /* there were no space separated elements */
+     if (count == 0)
+         return;
+ 
+     /* Move opt to the exact arg position*/
+     for (; *opts != '\0'; opts++)
+         if (*opts != ' ')
+             break;
+ 
+     /* There were spaces, but just that, nothing meaningful */
+     if (*opts == '\0') return;
+ 
+     /* Would it be better to use NAME_MAX or PATH_MAX, or any other portable
+        macro? */
+     _editor = malloc(256);
+     memcpy(_editor, editor, count);
+     _editor[count] = '\0';
+     editor = _editor;
+     options_string_to_vector(opts);
+ }
+ 
+ static void
+ options_string_to_vector(char *opts)
+ {
+   options_number = 8;
+   editor_options = mymalloc(options_number * sizeof(editor_options[0]));
+   int count, pos;
+ 
+   for (pos = 0; ; pos++) {
+     for (; *opts == ' '; opts++) ;
+ 
+     if (*opts == '\0')
+       return;
+ 
+     if (pos > (options_number - 1)) {
+       options_number += 8;
+       editor_options = myrealloc(editor_options, options_number * sizeof(editor_options[0]));
+     }
+ 
+     for (count = 0; ; count++)
+       if (opts[count] == ' ' || opts[count] == '\0')
+         break;
+ 
+     editor_options[pos] = mymalloc(256);
+     memcpy(editor_options[pos], opts, count);
+ 
+     /* just in case any options or argument (or both, like in opt=arg) is bigger
+      that the expected. I have seen some long options used in QEMU */
+     if (count > 255)
+       editor_options[pos][255] = '\0';
+     else
+       editor_options[pos][count] = '\0';
+ 
+     opts += count;
+   }
+ }
